/*
 * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003
 * Lehrstuhl fuer Technische Informatik, RWTH-Aachen, Germany
 * 
 * This file is part of the LTI-Computer Vision Library (LTI-Lib)
 *
 * The LTI-Lib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License (LGPL)
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * The LTI-Lib is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with the LTI-Lib; see the file LICENSE.  If
 * not, write to the Free Software Foundation, Inc., 59 Temple Place -
 * Suite 330, Boston, MA 02111-1307, USA.  
 */ 

#ifndef _LTI_DOCUMENTATION
#define _LTI_DOCUMENTATION

/** 

\mainpage LTI-Lib 

\section contents Contents

 - \ref intro
 - \ref license
 - \ref architecture
 - \ref classHierarchy
 - \ref examples
 - \ref howtonew
 - \ref compilers
 - \ref download
 - \ref links

\section intro Introduction

The term LTI-Lib encloses a collection of algorithms and data
structures commonly used in image processing and computer vision
applications.  It is written in C++ in order to allow efficient
programming techniques using an object-oriented approach.

Its main goal is to provide a system independent library, which
follows as much as possible the ANSI C++ standards.  It works on
different <a href="http://www.unix.org">Unix</a> platforms and on 
<a href="http://www.microsoft.com/windows">Microsoft's Windows</a>, but
it is specially maintained for <a href="http://www.linux.org">Linux</a> /
<a href="http://www.gnu.org/software/gcc/gcc.html">GCC</a> and 
<a href="http://www.microsoft.com/ntworkstation/default.asp">Windows NT</a> / 
<a href="http://www.microsoft.com/visualc">MS Visual C++</a>.

The LTI-Lib was created at the 
<a href="http://www.techinfo.rwth-aachen.de/index_e.html">Chair of
Technical Computer Science</a> at the 
<a href="http://www.rwth-aachen.de/zentral/aguid_english_default.htm">RWTH
Aachen University</a>.  It is the result of several years of research in
several difficult computer vision problems like visual object recognition,
vision for mobile service robots and gesture recognition.

These pages give some introductory information about how to use the
LTI-Lib.  The conditions of use for the LTI-Lib are given in \ref license.
Some important concepts necessary to understand the
library are shown in \ref architecture.
The section \ref classHierarchy presents a thematic organization of
many classes found in this library.  Using the links shown on the top
of this page you can browse the on-line programming reference.

Other useful information can be reached through the links in \ref contents
and in our <a href="../homepage/index.html">homepage</a>.

\section license License

Copyright (C) 1998-2003 by  
<a href="http://www.techinfo.rwth-aachen.de/index_e.html">Chair of
Technical Computer Science</a>, 
<a href="http://www.rwth-aachen.de/zentral/aguid_english_default.htm">RWTH
Aachen University</a>. 

The LTI-Lib is free software; permission to use, copy, modify, and
distribute this software and its documentation under the terms of the
GNU Lesser General Public License is hereby granted. No
representations are made about the suitability of this software for
any purpose. It is provided "as is" without express or implied
warranty. See the
<a href="http://www.gnu.org/copyleft/lesser.html#SEC1"> GNU Lesser General
Public License</a> for more details.

The LTI-Lib is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

More information can be found at http://www.gnu.org/licenses/licenses.html
 
<hr>

\section links Some important links

- <A HREF="http://www.techinfo.rwth-aachen.de/index_e.html">Chair of 
   Technical Computer Science</A>, RWTH-Aachen, Germany.  The LTI-Lib has its
   origin at the "Lehrstuhl fuer Technische Informatik (LTI)" in the 
   <a href="http://www.rwth-aachen.de/zentral/aguid_english_default.htm">RWTH
   Aachen University</a>. 
- <a href="http://sourceforge.net">SourceForge</a>. Open Source development
  website hosting the 
  <a href="http://sourceforge.net/projects/ltilib">LTI-Lib</a>.
- <A HREF="http://www.doxygen.org">Doxygen</A> Documentation tool used
  in the LTI-Lib.
- <A HREF="http://www.perl.org">PERL</A> Scripting language used in several
  tools of the LTI-Lib.
- <A HREF="http://www.gtk.org">GTK</A> (Gimp Toolkit) This widget library
  is used in several visualization objects of the LTI-Lib.

\section authors Authors

\subsection coordinators Coordinators

Pablo Alvarado (Linux),
Peter Doerfler (Linux),
Ulrich Canzler (Windows)

\subsection students Programmers

Suat Akyol,
Pablo Alvarado,
Daniel Beier,
Axel Berner,
Florian Bley,
Ulrich Canzler,
Peter Doerfler,
Thomas Erger,
Helmuth Euler,
Holger Fillbrandt,
Dorothee Finck,
Birgit Gehrke
Peter Gerber,
Claudia Goenner,
Xin Gu,
Michael Haehnel,
Christian Harte,
Bastian Ibach,
Torsten Kaemper,
Thomas Krueger,
Frederik Lange,
Henning Luepschen,
Peter Mathes,
Alexandros Matsikis,
Bernd Mussmann,
Jens Paustenbach,
Norman Pfeil,
Vlad Popovici,
Markus Radermacher,
Jens Rietzschel,
Daniel Ruijters,
Thomas Rusert,
Volker Schmirgel,
Stefan Syberichs,
Guy Wafo Moudhe,
Ruediger Weiler,
Jochen Wickel ,
Benjamin Winkler,
Xinghan Yu,
Marius Wolf,
Joerg Zieren

\date 1999-2003

\if SourceForge
\htmlinclude hits.shtml
\else
\htmlinclude hits.html
\endif

*/

#endif

