/*
 * Copyright (C) 1998, 1999, 2000, 2001
 * Lehrstuhl fuer Technische Informatik, RWTH-Aachen, Germany
 *
 * This file is part of the LTI-Computer Vision Library (LTI-Lib)
 *
 * The LTI-Lib is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License (LGPL)
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * The LTI-Lib is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with the LTI-Lib; see the file LICENSE.  If
 * not, write to the Free Software Foundation, Inc., 59 Temple Place -
 * Suite 330, Boston, MA 02111-1307, USA.
 */


/*----------------------------------------------------------------
 * project ....: LTI Digital Image/Signal Processing Library
 * file .......: ltiContinuousRandDist.cpp
 * authors ....: Thomas Rusert, Pablo Alvarado
 * organization: LTI, RWTH Aachen
 * creation ...: 21.04.99
 * revisions ..: $Id: ltiContinuousRandDist.cpp,v 1.4 2003/10/13 06:17:44 alvarado Exp $
 */

#include <cstdlib>
#include <ctime>
#include "ltiContinuousRandDist.h"

namespace lti  {

  // default constructor: initialization using system time

  continuousRandomDistribution::continuousRandomDistribution(bool reInit)
    : randomDistribution(reInit) {
  }

  // constructor: user-defined initialization
  continuousRandomDistribution::continuousRandomDistribution(const unsigned int theValue) 
    : randomDistribution(theValue) {
  }

  // destructor
  continuousRandomDistribution::~continuousRandomDistribution() {
  }

  // draws a value from [0; 1)
  double continuousRandomDistribution::draw() const {
    return random();
  }

  continuousRandomDistribution&
  continuousRandomDistribution::copy(const continuousRandomDistribution& other)
  {
    // nothing to be copied!

    return (*this);
  }

}

